//+------------------------------------------------------------------+
//|                                          adaptive price zone.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  2
#property indicator_color1   Lime
#property indicator_color2   Red
#property indicator_style1   STYLE_DOT
#property indicator_style2   STYLE_DOT

//
//
//
//
//

extern int    emaPeriod   = 20;
extern int    emaPrice    = PRICE_CLOSE;
extern double bandPercent = 2;

//
//
//
//
//

double upBuffer[];
double dnBuffer[];
double wrkBuffer[][4];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,upBuffer);
   SetIndexBuffer(1,dnBuffer);
   emaPeriod = MathMax(emaPeriod,1);
       alpha = 2.0 /(1.0+MathSqrt(emaPeriod));
   
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define emaa 0
#define emab 1
#define rnga 2
#define rngb 3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
         
   //
   //
   //
   //
   //
            
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,emaPrice,i);
      double range = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
         if (i==Bars-1)
         {
            upBuffer[i]        = price;
            dnBuffer[i]        = price;
            wrkBuffer[r][emaa] = price;
            wrkBuffer[r][emab] = price;
            wrkBuffer[r][rnga] = range;
            wrkBuffer[r][rngb] = range;
            continue;
         }
         wrkBuffer[r][emaa] = wrkBuffer[r-1][emaa]+alpha*(price             -wrkBuffer[r-1][emaa]);
         wrkBuffer[r][emab] = wrkBuffer[r-1][emab]+alpha*(wrkBuffer[r][emaa]-wrkBuffer[r-1][emab]);
         wrkBuffer[r][rnga] = wrkBuffer[r-1][rnga]+alpha*(range             -wrkBuffer[r-1][rnga]);
         wrkBuffer[r][rngb] = wrkBuffer[r-1][rngb]+alpha*(wrkBuffer[r][rnga]-wrkBuffer[r-1][rngb]);

         //
         //
         //
         //
         //
         
         upBuffer[i] = wrkBuffer[r][emab]+bandPercent*wrkBuffer[r][rngb];
         dnBuffer[i] = wrkBuffer[r][emab]-bandPercent*wrkBuffer[r][rngb];
   }
   return(0);
}